; math_acot.asm
;
; Assembly language source for the ACOT function:


            include math.inc
            
;  ACOT(x)- Computes the arccotangent of st(0) and 
;           leaves the result in st(0).                    
;           X cannot equal zero.                        
;           There must be at least one free register for
;           this function to operate properly.          
;                                                                
;           acot(x) = atan(1/x)                                 


            .code
math_acot   proc
            fld1            ; fpatan computes
            fpatan          ;  atan(st(0)/st(1)).
            ret
math_acot   endp
            end